from urandom import randint
from hpprime import fillrect, dimgrob, blit, keyboard, eval


def init_grille(random_mode, colonnes, lignes):
    if not random_mode :
        return [[0 for _ in range(colonnes)] for _ in range(lignes)]
        
    else:
        return [[randint(0, 1) for _ in range(colonnes)] for _ in range(lignes)]

def clear_kb():
        while keyboard() != 0:
            pass

def choisir_langue():
    print("Choisissez une langue / Choose a language:")
    print("1. Français")
    print("2. English")
    
    while True:
        choix = input("Entrez votre choix (1 ou 2)\nEnter your choice (1 or 2): \n\n\n\n\n\n\n\n\n\n")
        if choix == "1":
            print("Vous avez choisi le Français.")
            return "fr"
        elif choix == "2":
            print("You selected English.")
            return "en"
        else:
            print("Choix invalide, veuillez réessayer / Invalid choice, please try again.")

def is_random(language):
    if language == "fr":
        print("Comment souhaitez-vous initialiser le jeu ?")
        print("1. Initialisation aléatoire")
        print("2. Dessiner vos propres formes")
    else:
        print("How would you like to initialize the game?")
        print("1. Random initialization")
        print("2. Draw your own shapes")

    while True:
        choix = input("Votre choix (1 ou 2)\nYour choice (1 or 2): \n\n\n\n\n\n\n\n\n")
        if choix == "1":
            if language == "fr":
                print("\nVous avez choisi l'initialisation aléatoire.")
            else:
                print("\nYou chose random initialization.")
            return True
        elif choix == "2":
            if language == "fr":
                print("\nVous avez choisi de dessiner vos propres formes.")
            else:
                print("\nYou chose to draw your own shapes.")
            return False
        else:
            if language == "fr":
                print("Choix invalide, veuillez réessayer.")
            else:
                print("Invalid choice, please try again.")

def JeuDeLaVie(L, l, bg, sr, color_border_box, color_int_box, random_mode):
    lignes = L // sr  # Taille de la grille
    colonnes = l // sr 

    grille = init_grille(random_mode, colonnes, lignes)

    dimgrob(1, 320, 240, 0x0)
    

    def afficher_grille():
        """Affiche la grille actuelle."""
        fillrect(1, 0, 0, 320, 240, bg, bg)
        for x in range(lignes):
            for y in range(colonnes):
                if grille[x][y]:
                    fillrect(1, x * sr, y * sr, sr, sr, color_border_box, color_int_box)
        blit(0, 0, 0, 1)
        
    def time_wait():
      for _ in range(0,100000):
        pass

    def mode_edition():
        """Permet à l'utilisateur de modifier la grille."""
        curseur_x, curseur_y = L//sr//2, l//sr//2
        oldkb=-1
        oldkb_time=0
        while True:
            afficher_grille()
            # Affiche le curseur
            fillrect(1, curseur_x * sr, curseur_y * sr, sr, sr, 0xFFFF00,0xFFFF00)
            blit(0, 0, 0, 1)
            kb = keyboard()
            kb = -1 if kb == 0 else kb
            current_time = eval("TICKS()")
            if kb == oldkb and current_time - oldkb_time < 200:
                kb = -1
            else:
                oldkb = kb
                oldkb_time = current_time

            #time_wait()
            key = kb #keyboard()
            #if key != oldkb:
                
            if key == 2**37:  # Gauche
                curseur_x = (curseur_x - 1) % lignes
            elif key == 2**39:  # Droite
                curseur_x = (curseur_x + 1) % lignes
            elif key == 2**33:  # Haut
                curseur_y = (curseur_y - 1) % colonnes
            elif key == 2**43:  # Bas
                curseur_y = (curseur_y + 1) % colonnes
            elif key == 2**44:
                curseur_y = (curseur_y + 1) % colonnes
                curseur_x = (curseur_x + 1) % lignes
            elif key == 2**34 :
                curseur_x = (curseur_x + 1) % lignes
                curseur_y = (curseur_y - 1) % colonnes
            elif key == 2**32 :
                curseur_y = (curseur_y - 1) % colonnes
                curseur_x = (curseur_x - 1) % lignes
            elif key == 2**42 :
                curseur_y = (curseur_y + 1) % colonnes
                curseur_x = (curseur_x - 1) % lignes
            elif key == 2**30:  # Toggle cellule
                grille[curseur_x][curseur_y] = 1 - grille[curseur_x][curseur_y]
            elif key == 2**4:  # Quitter le mode édition
                break
    if not random_mode :
        mode_edition()  # Lancement du mode édition avant la simulation

    while True:
        afficher_grille()

        # Calcul de la nouvelle grille
        nouvelle_grille = [[0 for _ in range(colonnes)] for _ in range(lignes)]
        for x in range(lignes):
            for y in range(colonnes):
                voisins = 0
                for i in range(-1, 2):
                    for j in range(-1, 2):
                        if i != 0 or j != 0:
                            voisin_x = (x + i) % lignes
                            voisin_y = (y + j) % colonnes
                            voisins += grille[voisin_x][voisin_y]

                if grille[x][y]:
                    nouvelle_grille[x][y] = 1 if voisins == 2 or voisins == 3 else 0
                else:
                    nouvelle_grille[x][y] = 1 if voisins == 3 else 0

        grille = nouvelle_grille


print()
language=choisir_langue()
random_mode=is_random(language)

while True:
    try:
        size_pixel = int(input("Entrer la taille du pixel - Enter size pixel : "))
        if size_pixel <= 0:
            raise ValueError("La taille du pixel doit être un entier positif, mais vous avez entré {}.".format(size_pixel))
        break
    except ValueError as e:
        print("Entrée invalide : {}. Veuillez réessayer.".format(e))

clear_kb()
# Exemple d'appel
JeuDeLaVie(320, 240, 0x88, size_pixel , 0x888800, 0xffff00,random_mode)
